# coding: utf-8

"""
    Keap REST API

    Keap REST Core Service

    The version of the OpenAPI document: 2.70.0.784947
    Contact: api@keap.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from keap_core_v2_client.models.currency_value import CurrencyValue
from keap_core_v2_client.models.product_inventory import ProductInventory
from keap_core_v2_client.models.product_options import ProductOptions
from keap_core_v2_client.models.subscription_plan import SubscriptionPlan
from typing import Optional, Set
from typing_extensions import Self

class RestV2Product(BaseModel):
    """
    RestV2Product
    """ # noqa: E501
    active: Optional[StrictBool] = Field(default=None, description="True means active, False means inactive")
    categories: Optional[List[StrictStr]] = Field(default=None, description="List of category ids to indicate which categories this product will belong to. Can be empty.")
    city_taxable: Optional[StrictBool] = Field(default=None, description="If city-based taxes should be applied to this product")
    country_taxable: Optional[StrictBool] = Field(default=None, description="If country-based taxes should be applied to this product")
    description: Optional[StrictStr] = Field(default=None, description="Product long description")
    id: Optional[StrictStr] = Field(default=None, description="The product ID")
    inventory: Optional[ProductInventory] = None
    name: Optional[StrictStr] = Field(default=None, description="Product name")
    options: Optional[List[ProductOptions]] = Field(default=None, description="List of product options. Can be empty.")
    price: Optional[CurrencyValue] = None
    short_description: Optional[StrictStr] = Field(default=None, description="Product short description")
    sku: Optional[StrictStr] = Field(default=None, description="Product SKU")
    state_taxable: Optional[StrictBool] = Field(default=None, description="If state-based taxes should be applied to this product")
    storefront_hidden: Optional[StrictBool] = Field(default=None, description="If the product should not be shown in the storefront")
    subscription_only: Optional[StrictBool] = Field(default=None, description="If the product is a subscription-only product")
    subscription_plans: Optional[List[SubscriptionPlan]] = Field(default=None, description="List of subscription plans associated with the product. Can be empty.")
    taxable: Optional[StrictBool] = Field(default=None, description="Whether or not the product should be taxed")
    weight: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Product weight")
    additional_properties: Dict[str, Any] = {}
    __properties: ClassVar[List[str]] = ["active", "categories", "city_taxable", "country_taxable", "description", "id", "inventory", "name", "options", "price", "short_description", "sku", "state_taxable", "storefront_hidden", "subscription_only", "subscription_plans", "taxable", "weight"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of RestV2Product from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * Fields in `self.additional_properties` are added to the output dict.
        """
        excluded_fields: Set[str] = set([
            "additional_properties",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of inventory
        if self.inventory:
            _dict['inventory'] = self.inventory.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in options (list)
        _items = []
        if self.options:
            for _item_options in self.options:
                if _item_options:
                    _items.append(_item_options.to_dict())
            _dict['options'] = _items
        # override the default output from pydantic by calling `to_dict()` of price
        if self.price:
            _dict['price'] = self.price.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in subscription_plans (list)
        _items = []
        if self.subscription_plans:
            for _item_subscription_plans in self.subscription_plans:
                if _item_subscription_plans:
                    _items.append(_item_subscription_plans.to_dict())
            _dict['subscription_plans'] = _items
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of RestV2Product from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "active": obj.get("active"),
            "categories": obj.get("categories"),
            "city_taxable": obj.get("city_taxable"),
            "country_taxable": obj.get("country_taxable"),
            "description": obj.get("description"),
            "id": obj.get("id"),
            "inventory": ProductInventory.from_dict(obj["inventory"]) if obj.get("inventory") is not None else None,
            "name": obj.get("name"),
            "options": [ProductOptions.from_dict(_item) for _item in obj["options"]] if obj.get("options") is not None else None,
            "price": CurrencyValue.from_dict(obj["price"]) if obj.get("price") is not None else None,
            "short_description": obj.get("short_description"),
            "sku": obj.get("sku"),
            "state_taxable": obj.get("state_taxable"),
            "storefront_hidden": obj.get("storefront_hidden"),
            "subscription_only": obj.get("subscription_only"),
            "subscription_plans": [SubscriptionPlan.from_dict(_item) for _item in obj["subscription_plans"]] if obj.get("subscription_plans") is not None else None,
            "taxable": obj.get("taxable"),
            "weight": obj.get("weight")
        })
        # store additional fields in additional_properties
        for _key in obj.keys():
            if _key not in cls.__properties:
                _obj.additional_properties[_key] = obj.get(_key)

        return _obj


